/* clcal "command line calendar"
   clcal.c
   Copyright (C)  2004  Rob Newcater */

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/licenses/gpl.html
*/

/* http:// */

/* Rob Newcater		conception	29 Apr 2004 */
/* Rob Newcater		version 0.1	13 May 2004 */


/*************************************************************************/


#include "clcal.h"


/*************************************************************************/


int main(int argc, char *argv[])
{

int i;
int iArgx;
int iDayx;
int iTotx = 0;
int iSflag;
int iOneArg;
int iTwoArg;
int iPrint = 0;
int iPrintx = 0;
int iCountx = 0;
char szSearchRange[7];
char *szSearchReg;

if (argc < 2 || argc > 5)
   {
   PrintUsage(argv[0]);
   }


int iTitleDate;
int iTodayDate;
int iTodayEntry;
int iOtherDate;
int iOtherEntry;
int iPastDate;
int iPastEntry;

int iColours[7] = { 0, 0, 0, 0, 0, 0, 0 };   //colours array; is there an
int *pColArray0 = &iColours[0];        //easier way to do this?  :)
int *pColArray1 = &iColours[1];
int *pColArray2 = &iColours[2];
int *pColArray3 = &iColours[3];
int *pColArray4 = &iColours[4];
int *pColArray5 = &iColours[5];
int *pColArray6 = &iColours[6];
int *pColArray[7] = { pColArray0, pColArray1, pColArray2, pColArray3, pColArray4, pColArray5, pColArray6 };

Colour(pColArray);

iTitleDate = *pColArray[0];
iTodayDate = *pColArray[1];
iTodayEntry = *pColArray[2];
iOtherDate = *pColArray[3];
iOtherEntry = *pColArray[4];
iPastDate = *pColArray[5];
iPastEntry = *pColArray[6];


if (argc == 2)
   {
   iOneArg = strlen(argv[1]);

   if ((strcmp("-h", argv[1]) == 0) ||
       (strcmp("--help", argv[1]) == 0))
      { PrintHelp(); }
   else if ((strcmp("-v", argv[1]) == 0) ||
	    (strcmp("--version", argv[1]) == 0))
      { PrintVer(); }
   else if ((strcmp("-d", argv[1]) == 0) ||
	    (strcmp("--day", argv[1]) == 0))
      { iArgx = 1; iDayx = 1; }
   else if ((strcmp("-w", argv[1]) == 0) ||
	    (strcmp("--week", argv[1]) == 0))
      { iArgx = 1; iDayx = 7; }
   else if ((strcmp("-m", argv[1]) == 0) ||
	    (strcmp("--month", argv[1]) == 0))
      { iArgx = 1; iDayx = 30; }
   else if ((strcmp("-y", argv[1]) == 0) ||
	    (strcmp("--year", argv[1]) == 0))
      { iArgx = 1; iDayx = 365; }
   else { PrintUsage(argv[0]); }
   }


if (argc == 3)
   {
   iTwoArg = strlen(argv[1]);

   if ((strcmp("-d", argv[1]) == 0) ||
       (strcmp("--day", argv[1]) == 0) ||
       (strcmp("--days", argv[1]) == 0))
      {
      iDayx = 1;
      if (strspn(argv[2], "0123456789") == strlen(argv[2]))
	 {
	 iArgx = atoi(argv[2]);
	 }
      else { PrintUsage(argv[0]); }
      }
   else if ((strcmp("-w", argv[1]) == 0) ||
	    (strcmp("--week", argv[1]) == 0) ||
	    (strcmp("--weeks", argv[1]) == 0))
      {
      iDayx = 7;
      if (strspn(argv[2], "0123456789") == strlen(argv[2]))
	 {
	 iArgx = atoi(argv[2]);
	 }
      else { PrintUsage(argv[0]); }
      }
   else if ((strcmp("-m", argv[1]) == 0) ||
	    (strcmp("--month", argv[1]) == 0) ||
	    (strcmp("--months", argv[1]) == 0))
      {
      iDayx = 30;
      if (strspn(argv[2], "0123456789") == strlen(argv[2]))
	 {
	 iArgx = atoi(argv[2]);
	 }
      else { PrintUsage(argv[0]); }
      }
   else if ((strcmp("-y", argv[1]) == 0) ||
	    (strcmp("--year", argv[1]) == 0) ||
	    (strcmp("--years", argv[1]) == 0))
      {
      iDayx = 365;
      if (strspn(argv[2], "0123456789") == strlen(argv[2]))
	 {
	 iArgx = atoi(argv[2]);
	 }
      else { PrintUsage(argv[0]); }
      }
   else if ((strcmp("-s", argv[1]) == 0)||
	    (strcmp("--search", argv[1]) == 0) ||
	    (strcmp("--searchfwd", argv[1]) == 0))
      {
      iTotx = 365;
      PrintToday(iTitleDate);
      StartFSearch(iTotx, iTodayDate, iTodayEntry, iOtherDate, iOtherEntry, argv[2]);
      }

   else if ((strcmp("-b", argv[1]) == 0)||
	    (strcmp("--searchbck", argv[1]) == 0))
      {
      iTotx = 365;
      PrintToday(iTitleDate);
      StartBSearch(iTotx, iPastDate, iPastEntry, argv[2]);
      }

   else { PrintUsage(argv[0]); }
   }

if (argc == 4)
   {
   for ( i = 1 ; i < 4 ; i++ )
      {
      if ((strcmp("-s", argv[i]) == 0) ||
	 (strcmp("--search", argv[i]) == 0) ||
	 (strcmp("--searchfwd", argv[i]) == 0))
	 {
	 iSflag = 1;
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 else
	    {
	    szSearchReg = strdup(argv[i+1]);
	    }
	 }
      if ((strcmp("-b", argv[i]) == 0) ||
	 (strcmp("--searchbck", argv[i]) == 0))
	 {
	 iSflag = 2;
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 else
	    {
	    szSearchReg = strdup(argv[i+1]);
	    }
	 }
      if ((strcmp("-d", argv[i]) == 0) ||
          (strcmp("--day", argv[i]) == 0) ||
          (strcmp("--days", argv[i]) == 0))
	 {
	 iTotx = 1;
	 }
      if ((strcmp("-w", argv[i]) == 0) ||
          (strcmp("--week", argv[i]) == 0) ||
          (strcmp("--weeks", argv[i]) == 0))
	 {
	 iTotx = 7;
	 }
      if ((strcmp("-m", argv[i]) == 0) ||
          (strcmp("--month", argv[i]) == 0) ||
          (strcmp("--months", argv[i]) == 0))
	 {
	 iTotx = 30;
	 }
      if ((strcmp("-y", argv[i]) == 0) ||
          (strcmp("--year", argv[i]) == 0) ||
          (strcmp("--years", argv[i]) == 0))
	 {
	 iTotx = 365;
	 }
      }
   if (iTotx == 0)
      {
      PrintUsage(argv[0]);
      }
   if (iSflag == 1)
      {
      PrintToday(iTitleDate);
      StartFSearch(iTotx, iTodayDate, iTodayEntry, iOtherDate, iOtherEntry, szSearchReg);
      }
   else if (iSflag == 2)
      {
      PrintToday(iTitleDate);
      StartBSearch(iTotx, iPastDate, iPastEntry, szSearchReg);
      }
   else
      {
      PrintUsage(argv[0]);
      }

   }
//############# end of new argc4


if (argc == 5)
   {
   for ( i = 1 ; i < 5 ; i++ )
      {
      if ((strcmp("-s", argv[i]) == 0) ||
	 (strcmp("--search", argv[i]) == 0) ||
	 (strcmp("--searchfwd", argv[i]) == 0))
	 {
	 iSflag = 1;
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 else
	    {
	    szSearchReg = strdup(argv[i+1]);
	    }
	 }
      if ((strcmp("-b", argv[i]) == 0) ||
	 (strcmp("--searchbck", argv[i]) == 0))
	 {
	 iSflag = 2;
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 else
	    {
	    szSearchReg = strdup(argv[i+1]);
	    }
	 }
      if ((strcmp("-d", argv[i]) == 0) ||
          (strcmp("--day", argv[i]) == 0) ||
          (strcmp("--days", argv[i]) == 0))
	 {
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 if (strspn(argv[i+1], "0123456789") == strlen(argv[i+1]))
	    {
	    iTotx = atoi(argv[i+1]);
	    }
	 else { PrintUsage(argv[0]); }
	 }
      else if ((strcmp("-w", argv[i]) == 0) ||
          (strcmp("--week", argv[i]) == 0) ||
          (strcmp("--weeks", argv[i]) == 0))
	 {
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 if (strspn(argv[i+1], "0123456789") == strlen(argv[i+1]))
	    {
	    iTotx = (atoi(argv[i+1]) * 7);
	    }
	 else { PrintUsage(argv[0]); }
	 }
      else if ((strcmp("-m", argv[i]) == 0) ||
          (strcmp("--month", argv[i]) == 0) ||
          (strcmp("--months", argv[i]) == 0))
	 {
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 if (strspn(argv[i+1], "0123456789") == strlen(argv[i+1]))
	    {
	    iTotx = (atoi(argv[i+1]) * 30);
	    }
	 else { PrintUsage(argv[0]); }
	 }
      else if ((strcmp("-y", argv[i]) == 0) ||
          (strcmp("--year", argv[i]) == 0) ||
          (strcmp("--years", argv[i]) == 0))
	 {
	 if (argv[i+1] == NULL)
	    {
	    PrintUsage(argv[0]);
	    }
	 if (strspn(argv[i+1], "0123456789") == strlen(argv[i+1]))
	    {
	    iTotx = (atoi(argv[i+1]) * 365);
	    }
	 else { PrintUsage(argv[0]); }
	 }
      }
   if (iTotx == 0)
      {
      PrintUsage(argv[0]);
      }
   if (iSflag == 1)
      {
      PrintToday(iTitleDate);
      StartFSearch(iTotx, iTodayDate, iTodayEntry, iOtherDate, iOtherEntry, szSearchReg);
      }
   else if (iSflag == 2)
      {
      PrintToday(iTitleDate);
      StartBSearch(iTotx, iPastDate, iPastEntry, szSearchReg);
      }
   else
      {
      PrintUsage(argv[0]);
      }

   }
//############# end of new argc5


iTotx = iArgx * iDayx;

/*
Now need to pass colour variables to various print functions as required
*/

PrintToday(iTitleDate);

if (iTotx == 1)
   {
   iPrint = PrintCal0(iTodayDate, iTodayEntry);
   iCountx++;
   if (iPrint > 0)
      {
      iPrintx++;
      }
   printf("\n");
   }
else
   {
   iPrint = PrintCal0(iTodayDate, iTodayEntry);
   iCountx++;
   if (iPrint > 0)
      {
      iPrintx++;
      }
   for (i = 1 ; i < iTotx ; i++)
      {
      iPrint = PrintCalx(i, iOtherDate, iOtherEntry);
      iCountx++;
      if (iPrint > 0)
         {
         iPrintx++;
         }
      }
   printf("\n");
   }

if (iPrintx == iCountx)
   {
   if (iArgx == 1)
      {
      switch (iDayx)
	 {
	 case (1) :   printf("There are no entries in your calendar today.\n\n"); break;
	 case (7) :   printf("There are no entries in your calendar for the next week.\n\n"); break;
	 case (30) :  printf("There are no entries in your calendar for the next month.\n\n"); break;
	 case (365) : printf("There are no entries in your calendar during the next year.\n\n"); break;
	 }
      }
   if (iArgx > 1)
      {
      switch (iDayx)
	 {
	 case (1) :   strncpy(szSearchRange, "days", 7);
		      szSearchRange[sizeof(szSearchRange) - 1] = 0;
		      break;
	 case (7) :   strncpy(szSearchRange, "weeks", 7);
		      szSearchRange[sizeof(szSearchRange) - 1] = 0;
		      break;
	 case (30) :  strncpy(szSearchRange, "months", 7);
		      szSearchRange[sizeof(szSearchRange) - 1] = 0;
		      break;
	 case (365) : strncpy(szSearchRange, "years", 7);
		      szSearchRange[sizeof(szSearchRange) - 1] = 0;
		      break;
	 }
      printf("There are no entries in your calendar for the next %d %s.\n\n", iArgx, szSearchRange);
      }
   }

return 0;
}

/*************************************************************************/

void StartFSearch(int iTotx, int iTodayDate, int iTodayEntry, int iOtherDate, int iOtherEntry, char *szSearchReg)
{
int iSearch = 0;
int iSearchx = 0;
int iSCountx = 0;
int i;

iSearch = SearchFwd0(iTodayDate, iTodayEntry, szSearchReg);
iSCountx++;

if (iSearch > 0)
   {
   iSearchx++;
   }
for (i = 1 ; i < iTotx ; i++)
   {
   iSearch = SearchFwdx(i, iOtherDate, iOtherEntry, szSearchReg);
   iSCountx++;
   if (iSearch > 0)
      {
      iSearchx++;
      }
   }

printf("\n");

if (iSCountx == iSearchx)
   {
   printf("No entries containing \"%s\" were found.\n\n", szSearchReg);
   }

exit(0);

}

/*************************************************************************/

void StartBSearch(int iTotx, int iPastDate, int iPastEntry, char *szSearchReg)
{
int iSearch = 0;
int iSearchx = 0;
int iSCountx = 0;
int i;


if (iSearch > 0)
   {
   iSearchx++;
   }
for (i = iTotx ; i > 0 ; i--)
   {
   iSearch = SearchBckx(i, iPastDate, iPastEntry, szSearchReg);
   iSCountx++;
   if (iSearch > 0)
      {
      iSearchx++;
      }
   }

printf("\n");

if (iSCountx == iSearchx)
   {
   printf("No entries containing \"%s\" were found.\n\n", szSearchReg);
   }

exit(0);

}

/*************************************************************************/

