/* clcal "command line calendar"
   help.c
   Copyright (C)  2004  Rob Newcater */

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/licenses/gpl.html
*/

/* http:// */

/* Rob Newcater		conception	29 Apr 2004 */
/* Rob Newcater		version 0.1	13 May 2004 */


/**************************************************************************/


#include "help.h"


/**************************************************************************/

void PrintVer()
{
printf("clcal (Command Line Calendar) %s\n", CLCAL_VERSION);
printf("Copyright (C) 2004 Rob Newcater.\n\n");
printf("This program comes with ABSOLUTELY NO WARRANTY.\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions. See the file GPL.txt for details.\n\n");

exit(0);
}

/**************************************************************************/

void PrintUsage(char szClPath[])
{
fprintf(stderr, "usage:\t%s [ -d ] [ -day ] [ -days ] #\n", szClPath);
fprintf(stderr, "\t\t[ -w ] [ --week ] [ --weeks ] #\n");
fprintf(stderr, "\t\t[ -m ] [ --month ] [ --months ] #\n");
fprintf(stderr, "\t\t[ -y ] [ --year ] [ --years ] #\n");
fprintf(stderr, "\t\t[ -h ] [ --help ]\n");
fprintf(stderr, "\t\t[ -v ] [ --version ]\n");
fprintf(stderr, "\t\t[ -s ] [ --search ] [ --searchfwd ] <expression>\n");
fprintf(stderr, "\t\t[ -b ] [ --searchbck ] <expression>\n\n");

exit(1);
}

/*************************************************************************/

void PrintHelp()
{
printf("[1mclcal help[0m\n\n");

printf("[4mrequirements[0m\n");

printf("clcal requires you to have your calendar files set up correctly.  If they are\n");
printf("not set up correctly, clcal will produce no output.\n");
printf("Please see the README file which came with the source code for details.\n\n");

printf("[4moptions[0m\n");

printf("[1m-h[0m, [1m--help[0m\t     Prints this help page.\n");
printf("[1m-v[0m, [1m--version[0m    Prints version information.\n\n");
printf("[1m-d[0m #, [1m--day[0m #    Prints your calendar entries for # number of days,\n\t\t or one day (today) if no number is specified.\n");
printf("[1m-w[0m #, [1m--week[0m #   Prints your calendar entries for # number of weeks (etc).\n");
printf("[1m-m[0m #, [1m--month[0m #  Prints your calendar entries for # number of months (etc).\n");
printf("[1m-y[0m #, [1m--year[0m #   Prints your calendar entries for # number of years (etc).\n\n");
printf("[1m-s[0m xyz,          Performs a search ahead in your calendar entries for the\n");
printf("[1m--search[0m xyz     regular expression \"xyz\". The search is case insensitive.\n");
printf("[1m--searchfwd[0m xyz  The default is to search one year ahead, but this can be\n");
printf("                 tailored by combining with the period flags above.\n");
printf("                 e.g: \"clcal -s doctor -m\" or \"clcal -w 7 -s dentist\".\n");
printf("                 If your regular expression has spaces in it, put quotes\n");
printf("                 around it, e.g: clcal -s \"bank holiday\".\n\n");
printf("[1m-b[0m abc,          Performs a search back in your calendar's (past) entries\n");
printf("[1m--searchbck[0m abc  for the regular expression \"abc\". The search is case\n");
printf("                 insensitive.  The default search period is one year, and\n");
printf("                 may be modified in a similar way to the -s option.\n\n");

printf("Running clcal without any options will generate a brief usage message.\n\n");

exit(0);
}

/*************************************************************************/

